//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%399D65DB01A9.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%399D65DB01A9.cm

//## begin module%399D65DB01A9.cp preserve=no
//## end module%399D65DB01A9.cp

//## Module: EinsteinData%399D65DB01A9; Package specification
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/EinsteinData.h

#ifndef EINSTEINDATA_H
#define EINSTEINDATA_H 1

//## begin module%399D65DB01A9.additionalIncludes preserve=no
//## end module%399D65DB01A9.additionalIncludes

//## begin module%399D65DB01A9.includes preserve=yes
//## end module%399D65DB01A9.includes

// DataSet
#include <XSModel/Data/DataSet.h>
// EinsteinIO
#include <XSModel/DataFactory/EinsteinIO.h>
//## begin module%399D65DB01A9.declarations preserve=no
//## end module%399D65DB01A9.declarations

//## begin module%399D65DB01A9.additionalDeclarations preserve=yes
//## end module%399D65DB01A9.additionalDeclarations


//## begin EinsteinData%363DDB9902DB.preface preserve=yes
//## end EinsteinData%363DDB9902DB.preface

//## Class: EinsteinData%363DDB9902DB
//	Dataset specific implementation for Einstein CD-ROM
//	fits format data
//## Category: XSModel::Data%36349D4100F3
//## Subsystem: XSModel::Data%367691B49E40
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%39FDA765016D;DataSetBase { -> }
//## Uses: <unnamed>%3A02EA900079;SpectralData { -> }

class EinsteinData : public DataSet, //## Inherits: <unnamed>%3AA906A5037B
                     	public EinsteinIO  //## Inherits: <unnamed>%3BF52E9B029C
{
  //## begin EinsteinData%363DDB9902DB.initialDeclarations preserve=yes
  //## end EinsteinData%363DDB9902DB.initialDeclarations

  public:
    //## Constructors (generated)
      EinsteinData();

      EinsteinData(const EinsteinData &right);

    //## Destructor (generated)
      virtual ~EinsteinData();


    //## Other Operations (specified)
      //## Operation: clone%39940FAC00BF
      virtual EinsteinData* clone () const;

      //## Operation: fileFormat%399D655403BE
      //	type() returns true if the input filename is of the
      //	format corresponding to the class.
      bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: initialize%3A1C112900BB
      virtual void initialize (DataPrototype* proto, DataInputRecord& record);

      //## Operation: closeSourceFiles%3A39406902B0
      void closeSourceFiles ();

      //## Operation: reportResponse%3C07E8D00385
      virtual void reportResponse (size_t row) const;

      //## Operation: initializeFake%3E89E55B00F6
      virtual void initializeFake (DataPrototype* proto, FakeDataInputRecord& record);

      //## Operation: outputData%3E9D8C9D0171
      virtual void outputData ();

      //## Operation: getBackCorrLocation%3EB968E101EB
      virtual std::pair<string,size_t>  getBackCorrLocation (size_t rowNum, bool isCorr = false) const;

      //## Operation: getResponseName%47C4857E03D1
      virtual FakeDataInputRecord::Detectors getResponseName (size_t rowNum) const;

      //## Operation: getAncillaryLocation%47C4858A00A6
      virtual FakeDataInputRecord::Arfs getAncillaryLocation (size_t rowNum, const FakeDataInputRecord::Detectors& respInfo) const;

    // Additional Public Declarations
      //## begin EinsteinData%363DDB9902DB.public preserve=yes
      //## end EinsteinData%363DDB9902DB.public

  protected:

    //## Other Operations (specified)
      //## Operation: setArrays%3A01C403019C
      virtual void setArrays (size_t row = 0);

      //## Operation: scaleArrays%3A01E1F501B3
      virtual void scaleArrays (size_t row = 0);

      //## Operation: setDescription%3A1C4D8300BD
      virtual void setDescription (size_t spectrumNumber, size_t row = 0);

      //## Operation: setAncillaryData%3A26CF68005B
      //	Abstract function to be called by setData.
      //
      //	Invokes methods that instantiate ancilliary
      //	datasets in the case of DataSet and Response
      //	classes.
      //
      //	Default implementation is to do nothing.
      virtual bool setAncillaryData (size_t row = 0, int ancRow = -1);

    // Additional Protected Declarations
      //## begin EinsteinData%363DDB9902DB.protected preserve=yes
      //## end EinsteinData%363DDB9902DB.protected

  private:
    //## Assignment Operation (generated)
      EinsteinData & operator=(const EinsteinData &right);


    //## Other Operations (specified)
      //## Operation: defineArrays%39F7369F0265
      virtual void defineArrays ();

      //## Operation: groupQuality%39FEF2AA0376
      virtual void groupQuality ();

      //## Operation: copy%3A9578AC004E
      virtual void copy (const DataSet& right);

      //## Operation: Swap%3A9578F401F0
      virtual void Swap (DataSet& right);

    // Additional Private Declarations
      //## begin EinsteinData%363DDB9902DB.private preserve=yes
      //## end EinsteinData%363DDB9902DB.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin EinsteinData%363DDB9902DB.implementation preserve=yes
      //## end EinsteinData%363DDB9902DB.implementation

};

//## begin EinsteinData%363DDB9902DB.postscript preserve=yes
//## end EinsteinData%363DDB9902DB.postscript

// Class EinsteinData 

//## begin module%399D65DB01A9.epilog preserve=yes
//## end module%399D65DB01A9.epilog


#endif
